using System;
using System.Configuration.Install;
using System.ComponentModel;
using System.Runtime.InteropServices;
using System.Diagnostics;
using System.Reflection;
using Microsoft.Win32;

namespace ContextExtend
{
    [RunInstaller(true)]
    public class ComInstaller : Installer
    {
        [DllImport("shell32.dll", EntryPoint = "ShellExecute")]
        public static extern int ShellExecuteA(int hwnd, string lpOperation, string lpFile, string lpParameters, string lpDirectory, int nShowCmd);

        public override void Install(System.Collections.IDictionary
        stateSaver)
        {

            RegistryKey RK = Registry.ClassesRoot.OpenSubKey(@"*\shellex\ContextMenuHandlers\ContextExtend");

            if (RK != null)
            {
                if (System.Windows.Forms.MessageBox.Show(@"
A previous installation has been detected.

As this program is tied to window's file explorer, you'll have to restart this process.

It's totally harmless, the only side effect being that all your
currently opened File explorer windows will be closed.

Press OK so as to restart explorer and resume this installation.", "ContextExtend - Important notice", System.Windows.Forms.MessageBoxButtons.OKCancel) == System.Windows.Forms.DialogResult.OK)
                {

                    Process p = Process.GetProcessesByName("explorer")[0];
                    p.Kill();

                    //As process.start opens an annoying explorer window pointing "my documents"
                    //Let's do it in an old-school way.
                    ShellExecuteA(0, "explorer.exe", "", "", "", 0);
                }
                else System.Windows.Forms.MessageBox.Show("Please note that this program may not work untill your computer is restarted.");
            }

            base.Install(stateSaver);

            RegistrationServices regsrv = new RegistrationServices();
            if (!regsrv.RegisterAssembly(this.GetType().Assembly,
            AssemblyRegistrationFlags.SetCodeBase))
            {
                throw new InstallException("Failed To Register for COM");
            }
        }

        public override void Uninstall(System.Collections.IDictionary
        savedState)
        {
            base.Uninstall(savedState);

            RegistrationServices regsrv = new RegistrationServices();
            if (!regsrv.UnregisterAssembly(this.GetType().Assembly))
            {
                throw new InstallException("Failed To Unregister for COM");
            }
        }
    }
}