using System;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Text;

namespace Win32
{
	public enum MIIM : uint
	{
		STATE = 0x00000001,
		ID = 0x00000002,
		SUBMENU = 0x00000004,
		CHECKMARKS = 0x00000008,
		TYPE = 0x00000010,
		DATA = 0x00000020,
		STRING = 0x00000040,
		BITMAP = 0x00000080,
		FTYPE = 0x00000100
	}

	public enum MF : uint
	{
		INSERT = 0x00000000,
		CHANGE = 0x00000080,
		APPEND = 0x00000100,
		DELETE = 0x00000200,
		REMOVE = 0x00001000,
		BYCOMMAND = 0x00000000,
		BYPOSITION = 0x00000400,
		SEPARATOR = 0x00000800,
		ENABLED = 0x00000000,
		GRAYED = 0x00000001,
		DISABLED = 0x00000002,
		UNCHECKED = 0x00000000,
		CHECKED = 0x00000008,
		USECHECKBITMAPS = 0x00000200,
		STRING = 0x00000000,
		BITMAP = 0x00000004,
		OWNERDRAW = 0x00000100,
		POPUP = 0x00000010,
		MENUBARBREAK = 0x00000020,
		MENUBREAK = 0x00000040,
		UNHILITE = 0x00000000,
		HILITE = 0x00000080,
		DEFAULT = 0x00001000,
		SYSMENU = 0x00002000,
		HELP = 0x00004000,
		RIGHTJUSTIFY = 0x00004000,
		MOUSESELECT = 0x00008000
	}

	public enum CLIPFORMAT : uint
	{
		CF_TEXT = 1,
		CF_BITMAP = 2,
		CF_METAFILEPICT= 3,
		CF_SYLK = 4,
		CF_DIF = 5,
		CF_TIFF = 6,
		CF_OEMTEXT = 7,
		CF_DIB = 8,
		CF_PALETTE = 9,
		CF_PENDATA = 10,
		CF_RIFF = 11,
		CF_WAVE = 12,
		CF_UNICODETEXT = 13,
		CF_ENHMETAFILE = 14,
		CF_HDROP = 15,
		CF_LOCALE = 16,
		CF_MAX = 17,

		CF_OWNERDISPLAY = 0x0080,
		CF_DSPTEXT = 0x0081,
		CF_DSPBITMAP = 0x0082,
		CF_DSPMETAFILEPICT = 0x0083,
		CF_DSPENHMETAFILE = 0x008E,

		CF_PRIVATEFIRST = 0x0200,
		CF_PRIVATELAST = 0x02FF,

		CF_GDIOBJFIRST = 0x0300,
		CF_GDIOBJLAST = 0x03FF
	}

	public enum DVASPECT : uint
	{
		DVASPECT_CONTENT = 1,
		DVASPECT_THUMBNAIL = 2,
		DVASPECT_ICON = 4,
		DVASPECT_DOCPRINT = 8
	}

	public enum TYMED : uint
	{
		TYMED_HGLOBAL = 1,
		TYMED_FILE = 2,
		TYMED_ISTREAM = 4,
		TYMED_ISTORAGE = 8,
		TYMED_GDI = 16,
		TYMED_MFPICT = 32,
		TYMED_ENHMF = 64,
		TYMED_NULL = 0
	}

	public enum GCS: uint
	{
		VERBA = 0x00000000,     
		HELPTEXTA = 0x00000001,   
		VALIDATEA = 0x00000002,   
		VERBW = 0x00000004,     
		HELPTEXTW = 0x00000005,   
		VALIDATEW = 0x00000006,   
		UNICODE = 0x00000004,     
		VERB = GCS.VERBA,
		HELPTEXT = GCS.HELPTEXTA,
		VALIDATE = GCS.VALIDATEA
	}

	[StructLayout(LayoutKind.Sequential)]
	public struct CMINVOKECOMMANDINFO 
	{
		public uint cbSize;
		public uint fMask;
		public int hwnd;
		public uint lpVerb;
		public uint lpParameters;
		public uint lpDirectory;
		int nShow;
		public uint dwHotKey;
		public int hIcon;
	}

	[StructLayout(LayoutKind.Sequential)]
	public struct MENUITEMINFO
	{
		public uint cbSize;
		public uint fMask;
		public uint fType;
		public uint fState;
		public int wID;
		public int hSubMenu;
		public int hbmpChecked;
		public int hbmpUnchecked;
		public int dwItemData;
		public string dwTypeData;
		public uint cch;
		public int hbmpItem;
	}

	[StructLayout(LayoutKind.Sequential)]
	public struct FORMATETC
	{
		public CLIPFORMAT cfFormat;
		public uint ptd;
		public DVASPECT dwAspect;
		public int lindex;
		public TYMED tymed;
	}

	[StructLayout(LayoutKind.Sequential)]
	public struct STGMEDIUM
	{
		public uint tymed;
		public uint hGlobal;
		public uint pUnkForRelease;
	}

	public class DllImports
	{
		[DllImport("shell32")]
		static public extern uint DragQueryFile(uint hDrop,uint iFile, StringBuilder buffer, int cch);

		[DllImport("user32")]
		static public extern int InsertMenuItem(uint hmenu, uint uposition, uint uflags, ref MENUITEMINFO mii);

		[DllImport("user32.dll")]
		static public extern bool InsertMenu (uint hMenu, uint wPosition, uint wFlags, uint wIDNewItem, string lpNewItem);

		[DllImport("user32")]
		static public extern int CreateMenu();

		[DllImport("user32")]
		public static extern int CreatePopupMenu();

		[DllImport("user32")]
		public static extern int SetMenuItemBitmaps(uint hMenu, int nPosition, int wFlags, uint hBitmapUnchecked, uint hBitmapChecked);

		[DllImport("user32")]
		public static extern IntPtr GetCursor();

		[DllImport("user32")]
		public static extern IntPtr SetCursor(IntPtr hCursor);
	}
}