using System;

namespace ContextExtend
{
	/// <summary>
	/// 
	/// </summary>
	public class CopyPathToClipboard : ContextExtend.ShellMenuContextItem
	{
		public CopyPathToClipboard()
		{
		}

		public override string name
		{
			get
			{
				return "Copy Full Path to Clipboard";
			}
		}

		public override void Run(ref Win32.CMINVOKECOMMANDINFO pici )
		{
			System.Text.StringBuilder	sb = new System.Text.StringBuilder();

			if (System.Windows.Forms.Control.ModifierKeys == System.Windows.Forms.Keys.Shift)
				sb.Append(System.Windows.Forms.Clipboard.GetDataObject().GetData(System.Windows.Forms.DataFormats.Text));

			foreach ( System.IO.FileInfo fileInfo in fileList )
			{
				if (sb.Length != 0 ) 
					sb.AppendFormat("\r\n{0}", fileInfo.FullName );
				else
					sb.Append( fileInfo.FullName );
			}

			foreach ( System.IO.DirectoryInfo directoryInfo in directoryList )
			{
				if (sb.Length != 0 ) 
					sb.AppendFormat("\r\n{0}", directoryInfo.FullName );
				else
					sb.Append( directoryInfo.FullName );
			}
			
	        System.Windows.Forms.Clipboard.SetDataObject( sb.ToString() );
		}


	}
}
