using System;

namespace ContextExtend
{
	/// <summary>
	/// 
	/// </summary>
	public class UnlockFiles : ContextExtend.ShellMenuContextItem
	{
		public UnlockFiles()
		{
		}

		public override string name
		{
			get
			{
				if (System.Windows.Forms.Control.ModifierKeys == System.Windows.Forms.Keys.Shift)
					return "Lock Files";
				else
					return "Unlock Files";
			}
		}

		public override bool Handles(System.IO.DirectoryInfo directoryInfo)
		{
			return false;
		}

		public override bool Handles(System.IO.FileInfo fileInfo)
		{ 
			// If shift is pressed on left click, the it will lock the files, else it will unlok the files
			if (System.Windows.Forms.Control.ModifierKeys == System.Windows.Forms.Keys.Shift)
                return ((fileInfo.Attributes & System.IO.FileAttributes.ReadOnly) != System.IO.FileAttributes.ReadOnly);
			else
				return ((fileInfo.Attributes & System.IO.FileAttributes.ReadOnly) == System.IO.FileAttributes.ReadOnly);
		}

		public override void Run(ref Win32.CMINVOKECOMMANDINFO pici )
		{
			// For each file, change the read only flag
			foreach ( System.IO.FileInfo fileInfo in fileList )
			{
				if ( (fileInfo.Attributes & System.IO.FileAttributes.ReadOnly) == System.IO.FileAttributes.ReadOnly )
					fileInfo.Attributes = (System.IO.FileAttributes)((int)fileInfo.Attributes - (int)System.IO.FileAttributes.ReadOnly);
				else
					fileInfo.Attributes = (System.IO.FileAttributes)((int)fileInfo.Attributes + (int)System.IO.FileAttributes.ReadOnly);
			}
		}
	}
}
